;---------------------------------------------------------------------
; runtime library
;  2006/05/02, 2010/03/01
;  nasm -f elf runtime.asm
;  ld -Tbss 0x080A0000 runtime.o -o rt.bin
;  ( ld -Tbss 0x080A0000 -melf_i386 runtime.o -o rt.bin )
;  strip rt.bin
;  rvtl  liblist.vtl
;---------------------------------------------------------------------

%ifndef  NO_FB
  %define FRAME_BUFFER
%endif

        global  _start
BITS 32
        align   4
_start:
        jmp     main
        align   4
        dd      (main - $$ + 0x80)/4 ; main offset(word)
        dd      Init
        dd      Exit
        dd      ExitN
        dd      OutString
        dd      OutPString
        dd      OutAsciiZ
        dd      StrLen
        dd      OutChar
        dd      OutChar4
        dd      NewLine
        dd      BackSpace
        dd      PrintBinary
        dd      PrintOctal
        dd      PrintHex2
        dd      PrintHex4
        dd      PrintHex8
        dd      PrintHex
        dd      PrintLeftU
        dd      PrintLeft
        dd      PrintRight0
        dd      PrintRightU
        dd      PrintRight
        dd      InChar
        dd      InputLine0
        dd      READ_LINE2
        dd      READ_LINE3
        dd      READ_LINE
        dd      GET_TERMIOS
        dd      SET_TERMIOS
        dd      RESTORE_TERMIOS
        dd      RealKey
        dd      WinSize
        dd      fropen
        dd      fwopen
        dd      fclose
        dd      sgenrand
        dd      genrand
        dd      GetTime
        dd      USleep
        dd      ForkExec
        dd      GetString2
        dd      CopyString
        dd      NumInput
        dd      StringInput
        dd      GetArg
        dd      GetEnv
        dd      FileWrite
        dd      FileSize
        dd      FileRead
        dd      URL_Decode
        dd      DispFile
        dd      FGetArg
%ifdef FRAME_BUFFER
        dd      fbdev_open
        dd      fbdev_close
        dd      fb_get_fscreen
        dd      fb_get_screen
        dd      fb_set_screen
        dd      fb_copy_scinfo
        dd      fb_map_screen
        dd      fb_unmap_screen
        dd      fb_get_colormap
        dd      fb_set_colormap
        dd      fb_test_colormap
        dd      fb_restore_sc
        dd      fb_restore_cmap
        dd      LineDraw
        dd      Dot
        dd      PatternTransfer
        dd      PatternTransfer2
        dd      MPatternTransfer
        dd      PatternFill
        dd      FrameBufferFill
        dd      MemCopy
        dd      OpenFB
%endif
        dd      Oct2Bin
        dd      0x90909090

%ifndef __SYSCALL_INC
%include "syscall.inc"
%endif

%ifndef __STDIO_INC
%include "stdio.inc"
%endif
%include "vtllib2.inc"

section .text

%assign         ARGMAX      15
%assign         FNAMEMAX    256

;---------------------------------------------------------------------
; R[h  esi ͕ϐ̈擪ƂĂ
;---------------------------------------------------------------------
Init:
                mov     ebp, esp
                add     ebp, 4                  ; skip return address
                mov     edi, argc
                mov     ebx, [ebp]              ; ebx = argc
                mov     [edi], ebx              ; argc ̐ۑ
                add     ebp, 4
                mov     [edi + 4], ebp          ; argvp z擪ۑ
                lea     eax, [ebp+ebx*4+4]      ; ϐAhX擾
                mov     [edi + 8], eax          ; envp ϐ̈̕ۑ
                call    GET_TERMIOS             ; termios ̕ۑ
                call    SET_TERMIOS             ; [̃[JGR[OFF
                mov     eax, 672274774          ; V[hl
                xor     ecx, ecx
                mov     cl, '`'                 ; V[hݒ
                mov     [esi+ecx*4], eax
                call    sgenrand
                ret

;---------------------------------------------------------------------
; Mersenne Twister
;     From original code in C by Takuji Nishimura(mt19937int.c).
;---------------------------------------------------------------------
%assign         N   624
%assign         M   397

;---------------------------------------------------------------------
; Initialize Mersenne Twister
;   enter eax : seed
;---------------------------------------------------------------------
sgenrand:
                pusha
                mov     esi, N
                mov     ebx, 69069
                mov     ebp, 0xffff0000
                xor     edx, edx
    .loop:
                mov     edi, eax                ; eax : seed
                and     edi, ebp                ; 0xffff0000
                imul    eax, ebx                ; seed * 69069
                inc     eax
                mov     ecx, eax
                and     ecx, ebp                ; 0xffff0000
                shr     ecx, 16
                or      ecx, edi
                mov     [mt+edx*4], ecx         ; mt[ebx]
                imul    eax, ebx                ; 69069
                inc     eax                     ; seed
                inc     edx
                cmp     edx, esi
                jl      .loop
                mov     dword [mti], esi        ; N:624
                popa
                ret

;---------------------------------------------------------------------
; Generate Random Number
;   return eax : random number
;---------------------------------------------------------------------
genrand:
                pusha
                mov     esi, mt
                mov     edi, mti
                mov     eax, [edi]
                mov     ecx, N-1
                cmp     eax, ecx                ; 623
                jle     .genrand2
                mov     ebp, mag01
                shl     ecx, 2                  ; (N-1)*4
                xor     ebx, ebx

    .loop1:     call    .common
                xor     eax, [esi+ebx+M*4]      ; mt[kk+M]
                call    .common2
                cmp     ebx, (N-M-1)*4          ; N-M-1
                jle     .loop1
                cmp     ebx, ecx                ; (N-1)*4
                jge     .next

    .loop2:     call    .common
                xor     eax, [esi+ebx+(M-N)*4]  ; (M-N=-227)
                call    .common2
                cmp     ebx, ecx                ; (N-1)*4
                jl      .loop2

    .next:
                mov     edx, [esi+ecx]          ; (N-1)*4
                mov     eax, [esi]
                call    .common1
                xor     eax, [esi+(M-1)*4]
                call    .common2                ; ebx = ecx
                xor     eax, eax
                mov     [edi], eax              ; mti=0

    .genrand2:  mov     eax, [edi]
                mov     edx, [esi+eax*4]        ; mt[mti]
                inc     dword [edi]             ; mti++
                mov     eax, edx
                shr     eax, 11
                xor     edx, eax
                mov     eax, edx
                shl     eax, 7
                and     eax, 0x9d2c5680         ; TEMPERING_MASK_B
                xor     edx, eax
                mov     eax, edx
                shl     eax, 15
                and     eax, 0xefc60000         ; TEMPERING_MASK_C
                xor     edx, eax
                mov     eax, edx
                shr     eax, 18
                xor     edx, eax
                mov     [esp+28], edx           ; return eax
                popa
                ret

    .common:    mov     edx, [esi+ebx]
                mov     eax, [esi+ebx+4]
    .common1:   and     edx, 0x80000000
                and     eax, 0x7fffffff
                or      edx, eax
                mov     eax, edx
                shr     eax, 1
                ret

    .common2:   and     edx, byte 1
                xor     eax, [ebp+edx*4]
                mov     [esi+ebx], eax
                add     ebx, byte 4
                ret

;==============================================================
mag01           dd 0x00000000
                dd 0x9908b0df

;==============================================================

;-------------------------------------------------------------------------
; UNIXԂ}CNbPʂŕԂ
; ecx:sec, edx:usec
;-------------------------------------------------------------------------
GetTime:
                push    edi
                push    eax
                push    ebx
                mov     edi, TV
                mov     eax, SYS_gettimeofday
                mov     ebx, edi
                lea     ecx, [edi + 8]      ; TZ
                int     0x80
                mov     ecx, [edi]          ; sec
                mov     edx, [edi + 4]      ; usec
                pop     ebx
                pop     eax
                pop     edi
                ret

;-------------------------------------------------------------------------
; }CNbPʂ̃X[v _=n
; eax Ƀ}CNbݒ
;-------------------------------------------------------------------------
USleep:
                pusha
                xor     ebx, ebx
                mov     edi, TV
                mov     [edi], ebx          ; sec  0
                mov     [edi+4], eax        ; usec
                mov     eax, SYS_newselect
                mov     ecx, ebx
                mov     edx, ebx
                mov     esi, ebx
                int     0x80
                popa
                ret

;-------------------------------------------------------------------------
; ForkExec , OvO̎s
; FileName ɕۑꂽOvOs
;-------------------------------------------------------------------------
ForkExec:
                pusha
                call    ParseArg            ; R}hs̉
                mov     edi, ebx            ; _CNgt@C
                inc     edx                 ; qvZX̐
                mov     ecx, exarg          ; char ** argp
                xor     ebp, ebp            ; 擪vZX
                cmp     edx, 1
                ja      .loop               ; pCvKv
                mov     eax, SYS_fork       ; pCvsv̏ꍇ
                int     0x80
                test    eax, eax
                je      .child              ; pid  0 ȂqvZX
                jmp     short .wait
    .loop:
                mov     esi, ipipe          ; pCvI[v
                mov     eax, SYS_pipe
                mov     ebx, esi            ; esi  pipe_fd z擪
                int     0x80                ; pipe

        ;------------------------------------------------------------
        ; fork
        ;------------------------------------------------------------
                mov     eax, SYS_fork
                int     0x80
                test    eax, eax
                je      .child              ; pid  0 ȂqvZX

        ;------------------------------------------------------------
        ; evZX̏
        ;------------------------------------------------------------
                test    ebp, ebp            ; 擪vZX?
                je      .not1st
                call    close_old_pipe
    .not1st:    push    eax                 ; qvZX pid ̕ۑ
                mov     eax, [esi]          ; pCv fd ̈ړ
                mov     [esi+8], eax
                mov     eax, [esi+4]
                mov     [esi+12], eax
                pop     eax                 ; qvZX pid ̕A
                dec     edx                 ; cqvZX̐
                je      .done
    .findargp:  add     ecx, 4              ; ̃R}hT
                cmp     dword[ecx], 0       ; ؂T
                jne     .findargp
                add     ecx, 4              ; ̃R}hݒ
                inc     ebp                 ; ͐擪vZXł͂Ȃ
                jmp     short   .loop
    .done:
                call    close_new_pipe
    .wait:
                mov     ebx, eax            ; ŌɋNvZXpid
                mov     eax, SYS_wait4      ; I҂
                mov     ecx, stat_addr
                mov     edx, WUNTRACED      ; WNOHANG
                mov     esi, ru             ; rusage
                int     0x80
                call    SET_TERMIOS         ; qvZX̐ݒ𕜋A
                popa
                ret

        ;------------------------------------------------------------
        ; qvZX̏
        ;------------------------------------------------------------
    .child:
                call    RESTORE_TERMIOS
                push    ecx                 ; ecx  char **argp ݒ
                dec     edx                 ; ŏIvZX`FbN
                jne     .pipe_out           ; ŏIvZXłȂ
                test    edi, edi            ; _CNg邩
                je      .pipe_in            ; _CNg, Wo
                mov     ebx, edi            ; _CNgt@C
                call    fwopen
                mov     ebx, eax            ; I[vς݂̃t@C fd
                mov     eax, SYS_dup2       ; Wo͂t@C
                xor     ecx, ecx
                inc     ecx                 ; Wo͂t@Cɍւ
                int     0x80                ; dup2
                call    fclose              ; ebx ɂ̓I[vfd
                jmp     short .pipe_in

    .pipe_out:  mov     eax, SYS_dup2       ; Wo͂pCv
                mov     ebx, [esi + 4]      ; VpCv̏ fd
                xor     ecx, ecx            ; new_fd
                inc     ecx                 ; Wo
                int     0x80                ; dup2
                call    close_new_pipe
    .pipe_in:   test    ebp, ebp            ; 擪vZXȂXLbv
                je      .execve
                mov     eax, SYS_dup2       ; W͂pCv
                mov     ebx, [esi+8]        ; ÕpCv̓Ǐo fd
                xor     ecx, ecx            ; new_fd W
                int     0x80                ; dup2
                call    close_old_pipe
    .execve:
                pop     ecx                 ; ecx  char **argp ݒ
                mov     eax, SYS_execve     ; ϐg
                mov     ebx, [ecx]          ; char * filename
                mov     edx, [envp]         ; char ** envp
                int     0x80
                ; not return
close_new_pipe:
                push    eax
                mov     ebx, [esi + 4]      ; o̓pCvN[Y
                call    fclose
                mov     ebx, [esi]          ; ̓pCvN[Y
                call    fclose
                pop     eax
                ret
close_old_pipe:
                push    eax
                mov     ebx, [esi + 12]     ; o̓pCvN[Y
                call    fclose
                mov     ebx, [esi + 8]      ; ̓pCvN[Y
                call    fclose
                pop     eax
                ret

;-------------------------------------------------------------------------
; execve p̈ݒ
; R}h̃obt@ FileName AsciiZɕϊă|C^̔zɐݒ
; edx  pCv̐ (qvZX-1) ԂD
; ebx Ƀ_CNgt@Cւ̃|C^ԂD
;-------------------------------------------------------------------------
ParseArg:
                push    edi
                push    esi
                xor     ecx, ecx            ; zCfbNX
                xor     edx, edx            ; pCṽJE^
                xor     ebx, ebx            ; _CNgtO
                mov     esi, FileName       ; R}h̃obt@
                mov     edi, exarg          ; |C^̔z擪
    .nextarg:
    .space:     mov     al, [esi]           ; A󔒂̃XLbv
                or      al, al              ; s`FbN
                je      .exit
                cmp     al, ' '
                jne     .pipe               ; pCṽ`FbN
                inc     esi                 ; 󔒂Ȃ玟̕
                jmp     short .space

    .pipe:      cmp     al, '|'             ; pCv?
                jne     .redirect
                inc     edx                 ; pCṽJE^
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; R}h̋؂ 0
                inc     ecx                 ; zCfbNX
                jmp     short .check_and_next

    .redirect:  cmp     al, '>'             ; _CNg?
                jne     .arg
                inc     ebx
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; R}h̋؂ 0
                inc     ecx                 ; zCfbNX
                jmp     short .check_and_next

    .arg:       mov     [edi + ecx*4], esi  ; ւ̃|C^o^
                inc     ecx
    .nextchar:  mov     al, [esi]           ; Xy[XT
                or      al, al              ; s`FbN
                je      .found2
                cmp     al, ' '
                je      .found
                inc     esi
                jmp     short .nextchar
    .found:     mov     byte[esi], 0        ; Xy[X 0 ɒu
                test    ebx, ebx            ; _CNgtO
                je      .check_and_next
    .found2:    test    ebx, ebx            ; _CNgtO
                je      .exit
                dec     ecx
                mov     ebx, [edi + ecx*4]
                inc     ecx
                jmp     short .exit

    .check_and_next:
                inc     esi
                cmp     ecx, ARGMAX
                jae     .exit
                jmp     short .nextarg

    .exit:
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; |C^z̍Ō
                pop     esi
                pop     edi
                ret

;-------------------------------------------------------------------------
; eax ̃AhXFileNameɃRs[(ASCIIZ)
;-------------------------------------------------------------------------
  GetString2:
                push    edi
                mov     ebx, eax
                xor     ecx, ecx
                mov     edi, FileName
    .next:      mov     al, [ebx + ecx]
                mov     [edi + ecx], al
                or      al, al
                je      .exit
                inc     ecx
                cmp     ecx, FNAMEMAX
                jb      .next
    .exit:      pop     edi
                ret

;-------------------------------------------------------------------------
; eax ̃AhX ebx ̃AhXɍőecx byte ASCIIZRs[
; Aecxɕ񐔂ԂBAhX̏ꍇ ecx ɕ񒷂Ԃ
;-------------------------------------------------------------------------
  CopyString:
                cmp     eax, ebx
                jnz     .sp0
                call    StrLen
                mov     ecx, eax
                ret

    .sp0:       push    edi
                push    esi
                push    edx
                mov     esi, eax
                mov     edi, ebx
                mov     edx, ecx
                cmp     eax, ebx
                je      .sp3
                xor     ecx, ecx
    .sp1:
                mov     al, [esi+ecx]
                mov     [edi+ecx], al
                inc     ecx
                cmp     ecx, edx
                je      .sp2
                or      al, al
                jne     .sp1
    .sp2:
                dec     ecx
    .sp4:       pop     edx
                pop     esi
                pop     edi
                ret

    .sp3:       call    StrLen
                mov     ecx, eax
                jmp     short .sp3

;-------------------------------------------------------------------------
; R\[10i16il ebx ɐlԂ
;-------------------------------------------------------------------------
NumInput:
                push    eax
                push    esi
                mov     eax, MAXLINE        ; 1 s
                mov     ebx, input          ; s[NGA
                call    READ_LINE3
                mov     esi, ebx
                call    Number
                pop     esi
                pop     eax
                ret

;-------------------------------------------------------------------------
; 10i
; ebx ɐlԂ, eax,ebx,ecx,esi gp
;-------------------------------------------------------------------------
Number:
                xor     ecx, ecx            ; ̐
                xor     ebx, ebx
                mov     al, [esi]
                inc     esi
                cmp     al, "$"
                je      Hex                 ; 16i
                cmp     al, "+"
                je      .EatSign
                cmp     al, "-"
                jne     .Num
                inc     ecx                 ; ̐
    .EatSign:
                mov     al, [esi]
                inc     esi
                call    IsNum
                jb      .exit               ; łȂΕԂ
                jmp     short .NumLoop
    .Num:
                call    IsNum
                jb      .exit
                sub     eax, '0'
    .NumLoop:
                imul    ebx, 10             ;
                add     ebx, eax
                mov     al, [esi]
                inc     esi
                call    IsNum
                jb      .exit
                sub     eax, '0'
                jae     .NumLoop

                or      ecx, ecx            ; ͕H
                je      .exit
                neg     ebx                 ; ɂ
    .exit:
                ret

;-------------------------------------------------------------------------
; 16i̕𐔒lɕϊ
; ebx ɐlԂ, eax,ebx gp
;-------------------------------------------------------------------------
Hex:
                xor     eax, eax
                xor     ebx, ebx
    .next:
                mov     al, [esi]
                inc     esi
                call    IsNum
                jb      .hex1
                sub     al, '0'             ; ɕϊ
                jmp     short .num
    .hex1:      cmp     al, 'A'
                jb      .exit               ; 'A' 菬Ȃ
                cmp     al, 'F'
                ja      .hex2
                sub     al, 55              ; -'A'+10 = -55
                jmp     short .num
    .hex2:      cmp     al, 'a'
                jb      .exit
                cmp     al, 'f'
                ja      .exit
                sub     al, 87              ; -'a'+10 = -87
    .num:
                shl     ebx, 4
                add     ebx, eax
                jmp     short .next
    .exit:
                ret

;-------------------------------------------------------------------------
; R\[ input ɕ
; eaxɕ(oCg)AebxɃobt@AhXԂ
;-------------------------------------------------------------------------
StringInput:
                push    eax
                mov     eax, MAXLINE        ; 1 s
                mov     ebx, input          ; s[NGA
                call    READ_LINE3
                pop     eax
                ret

;---------------------------------------------------------------------
; AL ̕16iǂ̃`FbN
; Ȃ琮ɕϊ AL Ԃ. 񐔎ȂL[Zbg
;---------------------------------------------------------------------
IsNum:          cmp     al, "0"             ; 0 - 9
                jb      IsHex2.no
                cmp     al, "9"
                ja      IsHex2.no
                clc
                ret

IsHex:          call    IsHex1              ; p?
                jae     .yes
                call    IsHex2
                jb      IsHex2.no
    .yes:       clc
                ret

IsHex1:         cmp     al, "A"             ; p啶(A-F)?
                jb      IsHex2.no
                cmp     al, "F"
                ja      IsHex2.no
                sub     al, "A"
                add     al, 10
                clc
                ret

IsHex2:         cmp     al, "a"             ; p(a-f)?
                jb      .no
                cmp     al, "f"
                ja      .no
                sub     al, "a"
                add     al, 10
                clc
                ret
    .no:        stc
                ret

IsHexNum:       call    IsHex               ; 16iH
                jae     .yes
                call    IsNum
                jb      IsHex2.no
                sub     al, "0"
    .yes:       clc
                ret

;-------------------------------------------------------------------------
; ebxɈԍ(0<=)A擪AhXeaxɕԂ
;-------------------------------------------------------------------------
GetArg:
                push    ecx
                push    edx
                mov     edx, argc
                mov     ecx, [edx]          ; ̌
                cmp     ebx, ecx            ; ԍƈ̐r
                jl      .L2                 ; ԍ < ̐
                mov     eax, [edx + 4]      ; argvp
                mov     eax, [eax]
    .L1:        mov     cl, [eax]           ; 0T
                inc     eax
                or      cl, cl
                jne     .L1
                dec     eax                 ; argv[0]EOLɐݒ
                jmp     short .L3
    .L2:        mov     edx, [edx + 4]      ; found [argp]
                mov     eax, [edx + ebx*4]  ; 擪AhX
    .L3:
                pop     edx
                pop     ecx
                ret

;-------------------------------------------------------------------------
; ebxɊϐ(0<=)A擪AhXeaxɕԂ
;-------------------------------------------------------------------------
GetEnv:
                push    ecx
                push    edx
                mov     edx, [envp]
                xor     ecx, ecx
    .L4:        cmp     dword[edx+ecx*4], 0 ; ϐ̐JEg
                je      .L5
                inc     ecx
                jmp     short .L4
    .L5:
                cmp     ebx, ecx
                jge     short .L6           ; ԍߑ
                mov     eax, [edx + ebx*4]  ; 擪AhX
                pop     edx
                pop     ecx
                ret
    .L6:        lea     eax, [edx + ecx*4]  ; null pointer Ԃ
                pop     edx
                pop     ecx
                ret

;-------------------------------------------------------------------------
; FileWrite
; eax:size, ebx:filename, ecx:buffer
;-------------------------------------------------------------------------
FileWrite:
                push    edi
                push    eax                 ; ݃TCY
                push    ecx                 ; obt@AhX
                ; t@CI[v
                ; enter   ebx: filename
                ; return  eax: fd, if error then eax will be negative.
                call    fwopen              ; open
                jle     .exit
                mov     edi, eax            ; FileDescW
                pop     ecx                 ; obt@AhX
                pop     edx                 ; ݃TCY
                mov     eax, SYS_write      ; VXeR[ԍ
                mov     ebx, edi            ; FileDescW
                int     0x80
                ; t@CN[Y
                ; ebx: t@CfBXNv^
                push    eax
                call    fclose
                pop     eax
                pop     edi
                ret
        .exit:
                pop     ecx
                pop     edx
                pop     edi
                ret

;-------------------------------------------------------------------------
; FileSize
; ebx:filename
;-------------------------------------------------------------------------
FileSize:
                pusha
                call    fropen              ; open
                jng     .exit
                mov     edi, eax            ; FileDescW
                mov     ebx, eax            ; P : fd
                mov     eax, SYS_lseek      ; VXeR[ԍ
                xor     ecx, ecx            ; Q : offset = 0
                mov     edx, SEEK_END       ; R : origin
                int     0x80                ; t@CTCY擾
                ; t@CN[Y
                mov     [esp+28], eax       ; return eax
                ; ebx: t@CfBXNv^
                call    fclose
                popa
                ret
        .exit:
                xor     eax, eax
                mov     [esp+28], eax       ; return eax
                popa
                ret

;-------------------------------------------------------------------------
; FileRead
; ebx:filename, ecx:buffer, edx:size
;-------------------------------------------------------------------------
FileRead:
                push    edi
                push    ecx
                push    edx
                call    fropen              ; open
                jng     .exit
                mov     edi, eax            ; FileDesc
                mov     ebx, edi            ; P : fd
                mov     eax, SYS_lseek      ; VXeR[ԍ
                xor     ecx, ecx            ; Q : offset=0
                xor     edx, edx            ; R : origin=0
                int     0x80                ; t@C擪ɃV[N
                pop     edx                 ; size
                pop     ecx                 ; buffer
                mov     eax, SYS_read       ; VXeR[ԍ
                mov     ebx, edi            ; FileDescW
                int     0x80                ; t@CŜǂ݂
                push    eax
                mov     ebx, edi            ; FileDescW
                call    fclose
                pop     eax
                pop     edi
                ret
        .exit:
                xor     eax, eax
                pop     edx
                pop     ecx
                pop     edi
                ret

;-------------------------------------------------------------------------
; URLfR[h
;
; eax URLGR[h̐擪ݒ
; ebx ɕύX͈͂̕ݒ
; ecx ɃfR[h̕擪ݒ
; eax ɃfR[h̕Ԃ
;-------------------------------------------------------------------------
URL_Decode:
                pusha
                mov     esi, eax
                mov     edi, ecx
                xor     eax, eax
                xor     ecx, ecx
                push    esi
    .next:
                mov     al, [esi]           ; GR[h
                cmp     al, '+'
                jne     .urld2
                mov     al, ' '
                mov     [edi + ecx], al     ; fR[h
                jmp     .urld4
    .urld2:
                cmp     al, '%'
                je      .urld3
                mov     [edi + ecx], al     ; GR[h
                jmp     .urld4

    .urld3:
                xor     edx, edx
                inc     esi
                mov     al, [esi]
                call    IsHexNum
                jb      .urld4
                add     dl, al
                inc     esi
                mov     al, [esi]
                call    IsHexNum
                jb      .urld4
                shl     dl, 4
                add     dl, al
                mov     [edi + ecx], dl
    .urld4:
                inc     esi
                inc     ecx
                mov     edx, [esp]          ; initial esi
                sub     edx, esi
                neg     edx
                cmp     edx, ebx
                jl      .next
                pop     esi
                xor     eax, eax
                mov     [edi + ecx], al
                mov     [esp+28], ecx       ; eax ɕԂ
                popa
                ret

;-------------------------------------------------------------------------
; t@Ce\
; ebx Ƀt@C
;-------------------------------------------------------------------------
DispFile:
                pusha
                call    fropen              ; open
                jng     .exit
                mov     edi, eax            ; FileDesc
                push    eax                 ; buffer on stack
    .next:
                mov     eax, SYS_read       ; VXeR[ԍ
                mov     ebx, edi            ; fd
                mov     ecx, esp            ; obt@w
                xor     edx, edx
                mov     dl, 4
                int     0x80                ; t@C 4 oCg
                test    eax, eax
                je      .done
                js      .done
                mov     edx, eax            ; # of bytes
                mov     eax, SYS_write
                xor     ebx, ebx
                inc     ebx                 ; 1:to stdout
                mov     ecx, esp
                int     0x80
                jmp     short .next

    .done:      pop     eax
                call    fclose
    .exit:      popa
                ret

;-------------------------------------------------------------------------
; 𕡐ASCIIZɕ
; eax 擪AhX
; ebx Ɉ|C^z̐擪AhXԂ
; ex.[ebx]   1ւ̃|C^
;    [ebx+4] 2ւ̃|C^
;    [ebx+8] 3ւ̃|C^ Ȃ. ŏI null
;-------------------------------------------------------------------------
FGetArg:
                call    GetString2
                call    ParseArg
                mov     ebx, exarg
                ret

%ifdef FRAME_BUFFER
%include      "fblib.inc"
%include      "vtlfb2.inc"

;---------------------------------------------------------------------------
; t[obt@gԂȂ΁Aeax Ƀt[obt@̐擪AhXA
; ebx ̎AhX55220oCg Virtual Screen Information 
; Physical Screen Information ݒ
OpenFB:
                call    fbdev_open
                js      .error
                call    fb_get_fscreen
                js      .error
                call    fb_get_screen
                js      .error
                call    fb_copy_scinfo
                call    fb_map_screen
                jns     .ok
                mov     ecx, eax
                neg     ecx
                cmp     ecx, 0xFF
                jbe     .error
    .ok:        mov     ebx, scinfo_data
                ret
    .error:     xor     eax, eax
                ret

%endif

;-------------------------------------------------------------------------
; 8i𐔒lɕϊ
; eax 8i𐔒lɕϊ eax ɕԂ
;-------------------------------------------------------------------------
Oct2Bin:
                push    ebx
                push    edi
                mov     edi, eax
                xor     ebx, ebx
                call    GetOctal
                ja      .exit
                mov     ebx, eax
    .OctLoop:
                call    GetOctal
                ja      .exit
                shl     ebx, 3              ;
                add     ebx, eax
                jmp     short .OctLoop
    .exit:
                mov     eax, ebx
                pop     edi
                pop     ebx
                ret

;-------------------------------------------------------------------------
; edi ̎8i𐔒lɕϊ eax ɕԂ
; 8iłȂǂ ja Ŕ\
;-------------------------------------------------------------------------
GetOctal:
                xor     eax, eax
                mov     al, [edi]
                inc     edi
                sub     al, '0'
                cmp     al, 7
                ret

section .text

;-------------------------------------------------------------------------
;
;-------------------------------------------------------------------------
        align   4
main:
        nop
        nop
        nop
        nop

l00         dd      FLOATING_TOP
l01         dd      HistLine
l02         dd      HistUpdate
l03         dd      wsize

l10         dd      input
l11         dd      history0
l12         dd      DirName
l13         dd      PathName
l14         dd      PartialName
l15         dd      FileNameBuffer
l16         dd      FNBPointer
l17         dd      FNCount
l18         dd      FNArray
l19         dd      old_termios
l20         dd      new_termios
l21         dd      new_sig
l22         dd      old_sig
l23         dd      TV
l24         dd      TZ
l25         dd      ru
l26         dd      dir_ent
l27         dd      file_stat
l28         dd      mti
l29         dd      mt
l30         dd      current_arg
l31         dd      argc
l32         dd      argvp
l33         dd      envp
l34         dd      argc_vtl
l35         dd      argp_vtl
l36         dd      exarg
l37         dd      ipipe
l38         dd      opipe
l39         dd      ipipe2
l40         dd      opipe2
l41         dd      FileName
l42         dd      stat_addr
%ifdef FRAME_BUFFER
f01         dd      fb_desc
f02         dd      fb_address
f03         dd      red_save
f04         dd      green_save
f05         dd      blue_save
f06         dd      red_data
f07         dd      green_data
f08         dd      blue_data
f09         dd      mmap_arg
f10         dd      colormap_save
f11         dd      colormap_data
f12         dd      scinfo_save
f13         dd      scinfo_data
f14         dd      fscinfo
%endif
l43         dd      dummy

;==============================================================
section .bss

mti             resd    1
mt              resd    624
current_arg     resd    1
argc            resd    1
argvp           resd    1
envp            resd    1           ; exarg - 12
argc_vtl        resd    1
argp_vtl        resd    1
exarg           resd    ARGMAX+1    ; execve p
ipipe           resd    1
opipe           resd    1
ipipe2          resd    1
opipe2          resd    1
FileName        resb    FNAMEMAX
stat_addr       resd    1
dummy           resd    1
